//--------------------------------------------------------------
// Press F1 to get help about using script.
// To access an object that is not located in the current class, start the call with Globals.
// When using events and timers be cautious not to generate memoryleaks,
// please see the help for more information.
//---------------------------------------------------------------

namespace Neo.ApplicationFramework.Generated
{
    using System.Windows.Forms;
    using System;
    using System.Drawing;
    using Neo.ApplicationFramework.Tools;
    using Neo.ApplicationFramework.Common.Graphics.Logic;
    using Neo.ApplicationFramework.Controls;
	using Neo.ApplicationFramework.Interfaces;

	//Added
	using Neo.ApplicationFramework.Interfaces.Reporting;
	using System.Diagnostics;
	using System.IO;
	using System.Security.Permissions;
	using System.Threading;
    
    
	public partial class Reporting
	{
		public string Path { get; set; }
		public string LastSavedReportName { get; private set; }

		private string generatedName = null;
		
		
		FileSystemWatcher watcher = new FileSystemWatcher();

		[PermissionSet(SecurityAction.Demand, Name="FullTrust")]
		public void Initialize()
		{
			watcher.Path = Path;
			watcher.IncludeSubdirectories = false;
			
			watcher.NotifyFilter = NotifyFilters.LastAccess | NotifyFilters.LastWrite
				| NotifyFilters.FileName | NotifyFilters.DirectoryName;
			
			watcher.Filter = "*.xls";
			
			watcher.Renamed += new RenamedEventHandler(ReportFolder_OnRenamedOrNewReport); //For some reason creating a report calls renamed event.
		}
		
		private void ReportFolder_OnRenamedOrNewReport(object sender, FileSystemEventArgs e)
		{
			generatedName = e.Name;
		//	MessageBox.Show("Renamed");
		}
		
		public void SaveReport(string filename)
		{
			Thread thread = new Thread(() => SaveReportAsync(filename));	
			thread.Start();
		}
		
		private void SaveReportAsync(string filename)
		{
			watcher.EnableRaisingEvents = true;
			
			try
			{
				generatedName = null;
				Globals.Reports.Report.Save(Path);
				
				int c = 0;
				
				while (c++ <= 5)
				{
					System.Threading.Thread.Sleep(1000);	//Check for reportgeneration every 1 second.
					
					if (generatedName != null)
					{
						string fullname = Path + @"\" + generatedName;
						
						try
						{
							File.Move(fullname, Path + @"\" + filename + ".xls");
							LastSavedReportName = filename;
						}
						
						catch(Exception ex)
						{
									
							if (File.Exists(fullname))
							{
								try
								{	
									File.Delete(fullname);
								}
								
								catch {}
							}
							
							MessageBox.Show(ex.Message);
						}
						
						break;	
					}
					
					if (c > 5) 	//At 5 seconds timeout.
					{	
						MessageBox.Show("Timeout");
					}
				}
			}
				
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message);
			}
				
			finally
			{
				watcher.EnableRaisingEvents = false;
			}
		}	
		
		public void OpenFolder(string filename) {
			
			try {
				
				Process p = new Process();
				
				p.StartInfo.FileName = Path + @"\" + filename;
				p.Start();
				p.Dispose();
				
			} catch(Exception ex) {
				
				MessageBox.Show(ex.Message);	
			}
		}
    }
}
